> ## Documentation Index
> Fetch the complete documentation index at: https://novu-c5de82d9-docs-homepage-redesign.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Track activity and engagement events

> Track activity and engagement events using the Novu REST API. Requires your environment secret key in the Authorization header.



## OpenAPI

````yaml POST /v2/inbound-webhooks/delivery-providers/{environmentId}/{integrationId}
openapi: 3.0.0
info:
  title: Novu API
  description: >-
    Novu REST API. Please see https://docs.novu.co/api-reference for more
    details.
  version: 3.15.0
  contact:
    name: Novu Support
    url: https://discord.gg/novu
    email: support@novu.co
  termsOfService: https://novu.co/terms
  license:
    name: MIT
    url: https://opensource.org/license/mit
servers:
  - url: https://api.novu.co
  - url: https://eu.api.novu.co
security:
  - secretKey: []
tags:
  - name: Events
    description: >-
      Events represent a change in state of a subscriber. They are used to
      trigger workflows, and enable you to send notifications to subscribers
      based on their actions.
    externalDocs:
      url: https://docs.novu.co/workflows
  - name: Subscribers
    description: >-
      A subscriber in Novu represents someone who should receive a message. A
      subscriber's profile information contains important attributes about the
      subscriber that will be used in messages (name, email). The subscriber
      object can contain other key-value pairs that can be used to further
      personalize your messages.
    externalDocs:
      url: https://docs.novu.co/subscribers/subscribers
  - name: Topics
    description: >-
      Topics are a way to group subscribers together so that they can be
      notified of events at once. A topic is identified by a custom key. This
      can be helpful for things like sending out marketing emails or notifying
      users of new features. Topics can also be used to send notifications to
      the subscribers who have been grouped together based on their interests,
      location, activities and much more.
    externalDocs:
      url: https://docs.novu.co/subscribers/topics
  - name: Integrations
    description: >-
      With the help of the Integration Store, you can easily integrate your
      favorite delivery provider. During the runtime of the API, the
      Integrations Store is responsible for storing the configurations of all
      the providers.
    externalDocs:
      url: https://docs.novu.co/platform/integrations/overview
  - name: Workflows
    description: >-
      All notifications are sent via a workflow. Each workflow acts as a
      container for the logic and blueprint that are associated with a type of
      notification in your system.
    externalDocs:
      url: https://docs.novu.co/workflows
  - name: Messages
    description: >-
      A message in Novu represents a notification delivered to a recipient on a
      particular channel. Messages contain information about the request that
      triggered its delivery, a view of the data sent to the recipient, and a
      timeline of its lifecycle events. Learn more about messages.
    externalDocs:
      url: https://docs.novu.co/workflows/messages
  - name: Environments
    description: >-
      Environments allow you to manage different stages of your application
      development lifecycle. Each environment has its own set of API keys and
      configurations, enabling you to separate development, staging, and
      production workflows.
    externalDocs:
      url: https://docs.novu.co/platform/environments
  - name: Layouts
    description: Layouts are reusable wrappers for your email notifications.
    externalDocs:
      url: https://docs.novu.co/platform/workflow/layouts
  - name: Translations
    description: Used to localize your notifications to different languages.
    externalDocs:
      url: https://docs.novu.co/platform/workflow/advanced-features/translations
  - name: Domains
    description: Used to manage your inbound email domains.
    externalDocs:
      url: https://docs.novu.co/platform/domains
externalDocs:
  description: Novu Documentation
  url: https://docs.novu.co
paths:
  /v2/inbound-webhooks/delivery-providers/{environmentId}/{integrationId}:
    post:
      tags:
        - Activity
      summary: Track provider activity and engagement events
      description: Track activity and engagement events for a specific delivery provider
      operationId: InboundWebhooksController_handleWebhook
      parameters:
        - name: environmentId
          required: true
          in: path
          description: The environment identifier
          schema:
            type: string
        - name: integrationId
          required: true
          in: path
          description: The integration identifier for the delivery provider
          schema:
            type: string
        - name: idempotency-key
          in: header
          description: A header for idempotency purposes
          required: false
          schema:
            type: string
      requestBody:
        required: true
        description: Webhook event payload from the delivery provider
        content:
          application/json:
            schema:
              type: object
              additionalProperties: true
              description: Generic webhook payload from delivery providers
      responses:
        '200':
          description: Successfully processed webhook events
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/WebhookResultDto'
      x-codeSamples:
        - lang: php
          label: PHP
          source: |-
            declare(strict_types=1);

            require 'vendor/autoload.php';

            use novu;

            $sdk = novu\Novu::builder()
                ->setSecurity(
                    'YOUR_SECRET_KEY_HERE'
                )
                ->build();



            $response = $sdk->activity->track(
                environmentId: '<id>',
                integrationId: '<id>',
                requestBody: [

                ]

            );

            if ($response->webhookResultDtos !== null) {
                // handle response
            }
        - lang: python
          label: Python
          source: |-
            from novu_py import Novu


            with Novu(
                secret_key="YOUR_SECRET_KEY_HERE",
            ) as novu:

                res = novu.activity.track(environment_id="<id>", integration_id="<id>", request_body={

                })

                # Handle response
                print(res)
        - lang: go
          label: Go
          source: "package main\n\nimport(\n\t\"context\"\n\t\"github.com/novuhq/novu-go/v3\"\n\t\"log\"\n)\n\nfunc main() {\n    ctx := context.Background()\n\n    s := v3.New(\n        v3.WithSecurity(\"YOUR_SECRET_KEY_HERE\"),\n    )\n\n    res, err := s.Activity.Track(ctx, \"<id>\", \"<id>\", map[string]any{\n\n    }, nil)\n    if err != nil {\n        log.Fatal(err)\n    }\n    if res.WebhookResultDtos != nil {\n        // handle response\n    }\n}"
        - lang: typescript
          label: TypeScript
          source: |-
            import { Novu } from "@novu/api";

            const novu = new Novu({
              secretKey: "YOUR_SECRET_KEY_HERE",
            });

            async function run() {
              const result = await novu.activity.track({
                environmentId: "<id>",
                integrationId: "<id>",
                requestBody: {

                },
              });

              console.log(result);
            }

            run();
        - lang: csharp
          label: Csharp (SDK)
          source: |-
            using Novu;
            using Novu.Models.Components;
            using System.Collections.Generic;

            var sdk = new NovuSDK(secretKey: "YOUR_SECRET_KEY_HERE");

            var res = await sdk.Activity.TrackAsync(
                environmentId: "<id>",
                integrationId: "<id>",
                requestBody: new Dictionary<string, object>() {

                }
            );

            // handle response
components:
  schemas:
    WebhookResultDto:
      type: object
      properties:
        id:
          type: string
          description: Unique identifier for the webhook result
        event:
          description: Event body containing the webhook event data
          allOf:
            - $ref: '#/components/schemas/EventBody'
      required:
        - id
        - event
    EventBody:
      type: object
      properties:
        status:
          type: string
          description: Status of the event
          enum:
            - opened
            - rejected
            - sent
            - deferred
            - delivered
            - bounced
            - dropped
            - clicked
            - blocked
            - spam
            - unsubscribed
            - delayed
            - complaint
            - created
            - delivered
            - accepted
            - queued
            - sending
            - sent
            - failed
            - undelivered
            - rejected
            - delivered
            - opened
            - dismissed
            - clicked
            - failed
        date:
          type: string
          description: Date of the event
        externalId:
          type: string
          description: External ID from the provider
        attempts:
          type: number
          description: Number of attempts
        response:
          type: string
          description: Response from the provider
        row:
          type: string
          description: Raw content from the provider webhook
          additionalProperties: true
      required:
        - status
        - date
  securitySchemes:
    secretKey:
      type: apiKey
      name: Authorization
      in: header
      description: >-
        API key authentication. Allowed headers-- "Authorization: ApiKey
        <novu_secret_key>".
      x-speakeasy-example: YOUR_SECRET_KEY_HERE

````